#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct interval {
    long long prvi;
    long long drugi;
};

int main()
{
    long long n, q;

    cin >> n >> q;

    long long pom1, pom2;

    vector<interval> intervali;


    for(int i=0; i<n; i++){
        cin >> pom1 >> pom2;
        interval a;
        a.prvi = pom1;
        a.drugi = pom2 + pom1 - 1;
        for(int j=0; j<i; j++){
            if((a.prvi >= intervali[j].prvi) && (a.prvi <= intervali[j].drugi)){
                a.prvi = intervali[j].drugi + 1;
                a.drugi = a.prvi + a.drugi-pom1;
                pom1 = a.prvi;
            };
        };
        intervali.push_back(a);
    };

    long long pitanja[q];

    for(int i=0; i<q; i++){
        cin >> pitanja[i];
    };

    long long suma;
    for(int i=0; i<q; i++){
        suma = 0;
        for(int j=0; j<n; j++){
            if((pitanja[i] > intervali[j].prvi) && (pitanja[i] > intervali[j].drugi)){
                suma = suma + (intervali[j].drugi - intervali[j].prvi + 1);
            };
            if((pitanja[i] > intervali[j].prvi) && (pitanja[i] <= intervali[j].drugi)){
                suma = suma + ((pitanja[i] - intervali[j].prvi) + 1);
                break;
            };
            if((pitanja[i] == intervali[j].prvi) && (pitanja[i] < intervali[j].drugi)){
                suma = suma + 1;
                break;
            };
            if((pitanja[i] < intervali[j].prvi) && (pitanja[i] < intervali[j].drugi)){
                break;
            };

        };

        cout << suma;
        if(i < q-1){
            cout << endl;
        };
    };

    return 0;
}